import { __assign, __rest } from "tslib";
import { faChevronDown, faChevronUp } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import classNames from "classnames";
import React from "react";
import useValue, { DefaultFormatter, DefaultParser } from "./Hooks/useValue";
export var InputNumber = React.forwardRef(function (props, ref) {
    var _a;
    var _b = props.prefixCls, prefixCls = _b === void 0 ? "xy-inputnumber" : _b, className = props.className, style = props.style, defaultValue = props.defaultValue, onChange = props.onChange, _c = props.parser, parser = _c === void 0 ? DefaultParser : _c, _d = props.showControl, showControl = _d === void 0 ? false : _d, _e = props.formatter, formatter = _e === void 0 ? DefaultFormatter : _e, precision = props.precision, min = props.min, max = props.max, _f = props.step, step = _f === void 0 ? 1 : _f, onKeyDown = props.onKeyDown, onBlur = props.onBlur, genericProps = __rest(props, ["prefixCls", "className", "style", "defaultValue", "onChange", "parser", "showControl", "formatter", "precision", "min", "max", "step", "onKeyDown", "onBlur"]);
    var _g = useValue(props), getFormatterInputValue = _g[0], inputValue = _g[1], setInputValue = _g[2], changeValue = _g[3], canIncrease = _g[4], canDecrease = _g[5], increase = _g[6], decrease = _g[7];
    var classString = classNames(prefixCls, className, (_a = {},
        _a[prefixCls + "-disabled"] = props.disabled,
        _a[prefixCls + "-showControl"] = showControl,
        _a));
    function changeHandle(event) {
        setInputValue(getFormatterInputValue(event.target.value));
    }
    function keyDownHandle(event) {
        if (onKeyDown) {
            onKeyDown(event);
        }
        var input = event.currentTarget;
        switch (event.keyCode) {
            // 回车
            case 13:
                changeValue(input.value);
                event.preventDefault();
                return;
            // 上方向
            case 38:
                increase();
                event.preventDefault();
                return;
            // 下方向
            case 40:
                decrease();
                event.preventDefault();
                return;
        }
    }
    function blurHandle(event) {
        changeValue(event.target.value);
        if (onBlur) {
            onBlur(event);
        }
    }
    function renderControl() {
        return (React.createElement("div", { className: prefixCls + "-control-wrap" },
            React.createElement("span", { className: classNames(prefixCls + "-control", "control-up", { disabled: !canIncrease() }), onClick: increase },
                React.createElement("span", { className: prefixCls + "-control-inner" },
                    React.createElement(FontAwesomeIcon, { icon: faChevronUp }))),
            React.createElement("span", { className: classNames(prefixCls + "-control", "control-down", { disabled: !canDecrease() }), onClick: decrease },
                React.createElement("span", { className: prefixCls + "-control-inner" },
                    React.createElement(FontAwesomeIcon, { icon: faChevronDown })))));
    }
    return (React.createElement("div", { className: classString, style: style, ref: ref },
        renderControl(),
        React.createElement("input", __assign({}, genericProps, { value: inputValue, autoComplete: "off", "aria-disabled": props.disabled, onChange: changeHandle, onKeyDown: keyDownHandle, onBlur: blurHandle, className: prefixCls + "-input" }))));
});
export default React.memo(InputNumber);
//# sourceMappingURL=index.js.map